/************************************************************************
 *  TEST_ST2.C								*
 *			Test von STRING-Funktionen (Teil 2)		*
 *			===================================		*
 *									*
 *  02.04.94	Bodo Wenzel	Erstellung (spezielle Version 51I)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

/* === Funktionsprototypen ============================================ */

puts_c(char *s);
str_c(char *s);

chr(char *s,char c);
rchr(char *s,char c);
len(char *s);
rev(char *s);

show(char *s1,char *s2);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char	s1[15];

  getchar();

  for (;;)
    {
    puts_c("Gestartet...\r\n");

    strcpy(s1,str_c("Teststring"));
    puts_c("--->\"");
    puts(s1);
    puts_c("\"\r\n");
    chr(s1,'T');
    chr(s1,'s');
    chr(s1,'g');
    chr(s1,'x');
    getchar();

    puts_c("--->\"");
    puts(s1);
    puts_c("\"\r\n");
    rchr(s1,'T');
    rchr(s1,'s');
    rchr(s1,'g');
    rchr(s1,'x');
    getchar();

    len(str_c(""));
    len(str_c("x"));
    len(str_c("Teststring"));
    getchar();

    rev(str_c(""));
    rev(str_c("x"));
    rev(str_c("Teststring"));
    getchar();
    }
  }

/* === Hilfsfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

char	str[15];

str_c(char *s)
/*----------*/
  {
  char	*p;

  p=str;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str);
  }

/* === Stringfunktionen =============================================== */

chr(char *s,char c)
/*---------------*/
  {
  char	*p;

  p=strchr(s,c);
  putchar('\'');
  putchar(c);
  puts_c("'>");
  show(s,p);
  }

rchr(char *s,char c)
/*----------------*/
  {
  char	*p;

  p=strrchr(s,c);
  putchar('\'');
  putchar(c);
  puts_c("'>");
  show(s,p);
  }

len(char *s)
/*--------*/
  {
  int	i;

  i=strlen(s);
  puts_c("len\"");
  puts(s);
  puts_c("\":");
  hex(i);
  puts_c("\r\n");
  }

rev(char *s)
/*--------*/
  {
  char	b[15];

  strcpy(b,s);
  reverse(b);
  puts_c("\"");
  puts(s);
  puts_c("\"~\"");
  puts(b);
  puts_c("\"\r\n");
  }

/* === Ausgabefunktionen ============================================== */

show(char *s1,char *s2)
/*-------------------*/
  {
  if (s2==NULL)
    puts_c("0\r\n");
  else
    {
    while (s2-->=s1)
      putchar(' ');
    puts_c("^\r\n");
    }
  }

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
