/************************************************************************
 *  TEST_TYP.C								*
 *			Test von CTYPE-Funktionen			*
 *			=========================			*
 *									*
 *  02.04.94	Bodo Wenzel	Erstellung (spezielle Version 51I)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "ctype.h"
#include "stdio.h"

/* === Funktionsprototypen ============================================ */

puts_c(char *s);

log(int l);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  int	  i;

  getchar();
  for (;;) {
    puts_c("Gestartet...\r\n");

    for (i=0; i<0x100; ++i)
      {
      if ((i&0x0F)==0x00)
	puts_c("c: alnum alpha digit lower upper space lower upper\r\n");
      hex(i);
      log(isalnum(i));
      log(isalpha(i));
      log(isdigit(i));
      log(islower(i));
      log(isupper(i));
      log(isspace(i));
      puts_c("	 ");
      hex(tolower(i));
      puts_c("	  ");
      hex(toupper(i));
      if ((i&0x0F)==0x0F)
	getchar();
      puts_c("\r\n");
      }
    }
  }

/* === Hilfsfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	clr	a
	mov	b,a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

/* === Ausgabefunktionen ============================================== */

log(int l)
/*------*/
  {
  if (l)
    puts_c("   1  ");
  else
    puts_c("   0  ");
  }

hex(int n)
/*------*/
  {
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
