/************************************************************************
 *  _CMP_TOS.C								*
 *	    Wert mit TOS vergleichen (Version fr MCS51 mit XDATA)	*
 *	    ======================================================	*
 *									*
 *  02.04.94	Bodo Wenzel	V1.0, Erstellung			*
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*	_comp_tos()	vergleicht Konstante in R6R7 mit dem Wert	*/
/*			auf dem Stack, wenn gleich, Z-Flag setzen	*/

_comp_tos()
/*-------*/
  {
#asm
	mov	a,r3		;z = (r67 == [r32-2])
	add	a,#low(-2)
	mov	dpl,a
	mov	a,r2
	addc	a,#high(-2)
	mov	dph,a
	movx	a,@dptr
	xrl	a,r6
	mov	b,a
	inc	dptr
	movx	a,@dptr
	xrl	a,r7
	orl	a,b
#endasm
  }

/* === Ende =========================================================== */
