/************************************************************************
 *  _SUP_INT.C								*
 *		Startup-Code mit INTs (Version fr MCS51 mit XDATA)	*
 *		===================================================	*
 *									*
 *  02.04.94	Bodo Wenzel	V1.0, Erstellung			*
 ************************************************************************/

/*		! ! !	A C H T U N G	! ! !				*/
/*	Dieses Modul mu als erstes kommen!				*/

/* -------------------------------------------------------------------- */
/*	Mit diesem Code wird jedes Programm gestartet. Weil es bei	*/
/*	Mikrocontrollern kein startendes Programm gibt, gibt es weder	*/
/*	eine Kommandozeile noch eine Rcksprungadresse! Daher mu	*/
/*	"main()" eine Endlosschleife enthalten. 			*/

/* === Globale Variablen ============================================== */

/*	nur bei linkbarem Ausgabecode oder hnlichen Gegebenheiten...
extern	char	*_stack;	/* Stack wird extern vereinbart 	*/

/* === Funktionsprototypen ============================================ */

main(); 			/* Hauptfunktion des Programms		*/

int0();
timer0();
int1();
timer1();
sio();				/* Interrupt-Servicefunktionen		*/

/* === Funktion ======================================================= */

_startup()
/*------*/
  {
#asm
	ajmp	_cc_startup01	;Copyright berspringen

	org	00003H
	lcall	ccint0		;Interrupt fr Eingang 0
	reti

	org	0000BH
	lcall	cctimer0	;Interrupt fr Timer 0
	reti

	org	00013H
	lcall	ccint1		;Interrupt fr Eingang 1
	reti

	org	0001BH
	lcall	cctimer1	;Interrupt fr Timer 1
	reti

	org	00023H
	lcall	ccsio		;Interrupt fr SIO
	reti

	db	"PINC fr MCS51 mit XDATA "
	db	"(C)1993-94 Bodo Wenzel"
_cc_startup01:
	mov	sp,#cc_stack-1	;Stackpointer setzen

	mov	TMOD,#020H
	mov	TH1,#-(QUARZ/12/16/9600)
	mov	SCON,#052H
	mov	PCON,#080H
	mov	TCON,#040H	;SIO initialisieren
#endasm

	main(); 		/* ohne Parameter aufrufen		*/
  }

/* === Ende =========================================================== */
