/************************************************************************
 *  GETCHAR.C                                                           *
 *          Zeichen von stdin lesen (Version fr Atari-TOS, long model) *
 *          =========================================================== *
 *                                                                      *
 *  22.08.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*      getchar()       liest ein Zeichen von der Standardeingabe,      */
/*                      liefert den ASCII-Wert, bei Spezialtasten       */
/*                      zuerst '\0', beim nchsten Aufruf den Scancode  */

#asm
cc_scan:
        dc.w    0               ;Hilfsvariable fr Scancode             */
#endasm

getchar()
/*-----*/
  {
#asm
        move.w  cc_scan,d0
        bne.s   cc_01           ;Scancode vorhanden ?

        move.w  #1,-(sp)
        trap    #1
        addq.l  #2,sp           ;Zeichen holen
        tst.b   d0
        bne.s   cc_01           ;ASCII-Wert vorhanden ?

        swap    d0
        move.w  d0,cc_scan      ;Scancode merken
        clr.l   d0              ;0 zurckgeben
        bra.s   cc_02

cc_01:
        clr.w   cc_scan         ;kein Scancode mehr
        and.l   #$FF,d0         ;als char maskieren
cc_02:
#endasm
  }

/* === Ende =========================================================== */
