/************************************************************************
 *  GETS.C                                                              *
 *          String von stdin lesen (Version fr Atari-TOS, word model)  *
 *          ==========================================================  *
 *                                                                      *
 *  24.08.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*      gets            liest eine Zeichenkette von der Standardeingabe */
/*                      mit einer Begrenzung auf 80 Zeichen             */
/*      s               Zeiger auf Puffer (mindestens 80 Byte!)         */

gets(char *s)
/*---------*/
  {
#asm
        move.w  -2(a6),d1
        lea     (a5,d1.w),a4    ;Zeiger auf Puffer holen

        move.b  -(a4),d4
        move.b  -(a4),d5        ;zwei Bytes davor retten

        move.b  #79,(a4)        ;maximal 79 Zeichen + '\0'
        pea     (a4)
        move.w  #$A,-(sp)
        trap    #1
        addq.l  #6,sp           ;Zeichenkette holen

        clr.l   d0
        move.b  1(a4),d0        ;Anzahl Zeichen

        move.b  d5,(a4)+
        move.b  d4,(a4)+        ;gerettete Bytes zurck

        clr.b   (a4,d0.w)       ;Ende der Zeichenkette setzen
#endasm
  }

/* === Ende =========================================================== */
