/************************************************************************
 *  _STARTUP.C                                                          *
 *              Startup-Code (Version fr Atari-TOS, word model)        *
 *              ================================================        *
 *                                                                      *
 *  24.08.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/*              ! ! !   A C H T U N G   ! ! !                           */
/*      Dieses Modul mu als erstes gelinkt werden!                     */

/* -------------------------------------------------------------------- */
/*      Mit diesem Code wird jedes Programm gestartet. Er liefert an    */
/*      den aufrufenden Proze den Wert der aufgerufenen "main"-        */
/*      Funktion zurck.                                                */

/* === Einfgedateien ================================================= */

#include "stdlib.h"

/* === Globale Variablen ============================================== */

        int     _app;           /* Flag 0=Accessory, 1=Programm         */
        char    *_basepage;     /* Zeiger auf die BASEPAGE              */
extern  char    *_stack;        /* Stack wird extern vereinbart         */

/* === Funktionsprototypen ============================================ */

main(char *arg);                /* Hauptfunktion des Programms          */

/* === Funktion ======================================================= */

_startup()
/*------*/
  {
#asm
        bra.s   cc_01           ;Copyright berspringen

        dc.b    "PINC fr Atari-TOS (word model) V1.0 "
        dc.b    "(C)1993 Bodo Wenzel",0
        even

cc_01:
        move.l  a0,d4
        bne.s   cc_02           ;bei Accessory hier BP-Zeiger

        move.l  4(sp),d4        ;sonst hier

        move.l  d4,a0
        move.l  #$100,d0
        add.l   12(a0),d0
        add.l   20(a0),d0
        add.l   28(a0),d0       ;bentigten Speicher berechnen

        lea     128(a0),a6
        clr.w   d1
        move.b  (a6)+,d1
        clr.b   (a6,d1.w)       ;Ende der Kommandozeile setzen

        move.l  d0,-(sp)
        pea     (a0)
        clr.w   -(sp)
        move.w  #$4A,-(sp)
        trap    #1
        lea     12(sp),sp       ;nicht bentigten Speicher freigeben

        st      d1              ;ist Programm
        bra.s   cc_03

cc_02:
        move.l  d4,a6
        add.l   #128,a6
        clr.w   (a6)            ;leere Kommandozeile
        sf      d1              ;ist Accessory
cc_03:
        ext.w   d1
        move.w  d1,cc_app       ;Art merken

        move.l  d4,a0
        lea     _bp,a1
        move.w  #256/2-1,d0
cc_04:
        move.w  (a0)+,(a1)+
        dbra    d0,cc_04        ;Basepage kopieren

        lea     cc_data,a5      ;Zeiger auf C-Daten setzen
        lea     cc_local,a6     ;Zeiger auf Variablen-Stack

        move.l  #cc_stack,d0
        and.l   #$FFFFFFFC,d0
        move.l  d0,sp           ;Unterprogramm-Stack setzen

        move.l  #_bp,d0
        sub.l   a5,d0
        move.w  d0,cc_basepage  ;Zeiger auf BP merken

        add.w   #129,d0
        move.w  d0,(a6)+        ;Zeiger auf Parameter von Hand
#endasm
/*      int     ret;                                                    */
/*      ret=main(arg);                                                  */
/*      char    *arg;                                                   */
        exit(main());           /* ohne Parameter aufrufen              */
  }

#asm
        data
cc_data:                        ;Anfang der C-Daten
        bss
_bp:    ds.b    256             ;Puffer fr Basepage

;als letztes Symbol im BSS "cc_local" vereinbaren,
;danach kommt der Stack...

        text
#endasm

/* === Ende =========================================================== */
