/************************************************************************
 *  STRNCMP.C                                                           *
 *                  STRING-Funktion strncmp() (fr PINC)                *
 *                  ====================================                *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*      strncmp()       vergleicht zwei Zeichenketten mit Begrenzung,   */
/*                      liefert <0 (d<s), 0 (d==s) und >0 (d>s)         */
/*      d               Zeiger auf erste Zeichenkette                   */
/*      s               Zeiger auf zweite Zeichenkette                  */
/*      n               Maximalzahl Zeichen                             */

strncmp(char *d,char *s,int n)
/*--------------------------*/
  {
  while (--n>=0 & *d==*s)
    {
    if (*s=='\0')
      return(0);
    ++d;
    ++s;
    }
  if (n<0)
    return(0);
  else
    return(*d-*s);
  }

/* === Ende =========================================================== */
