/************************************************************************
 *  SYMBOL.C                                                            *
 *                      Symbolverwaltung fr PINC                       *
 *                      =========================                       *
 *                                                                      *
 *  22.06.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

#include "pinc.h"
#include "preproc.h"

#define extern
#include "symbol.h"             /* Konstanten und Variablen             */

/* === Funktionen ===================================================== */

syminit()                       /* Initialisierung                      */
/*-----*/
  {
  symptr=symbeg;                /* Zeiger zurcksetzen                  */
  }

symname(char *name)             /* Text als Namen testen und kopieren   */
/*---------------*/
  {
  int   i;

  i=0;
  if (alpha(ppactch()))
    do
      if (i<NAMEEND)
        name[i++]=ppgetch();    /* Namenslnge begrenzen                */
      else
        ppgetch();
    while (alnum(ppch0()));
  name[i]='\0';
  return(i);
  }

symadd(char *name,char id,char type,int value)  /* Symbol merken        */
/*------------------------------------------*/
  {
  char  *s;
  int   *v;

  strcpy(symptr+SYM_NAME,name);
  symptr[SYM_ID]=id;
  symptr[SYM_TYPE]=type;
  v=symptr+SYM_OFFSET;
  *v=value;
  s=symptr;
  if (symptr>=symend)
    error("Zuviele Symbole");
  else
    symptr=symptr+SYMSIZE;
  return(s);
  }

symfind(char *name)             /* Symbol suchen                        */
/*---------------*/
  {
  char  *s;

  s=symptr;
  while ((s=s-SYMSIZE)>=symbeg)
    if (strcmp(name,s+SYM_NAME)==0)     /* Namen gefunden ?             */
      return(s);
  return(NULL);
  }

/* === Ende =========================================================== */
