;PINC C-Compiler V1.0, Copyright 1993 Bodo Wenzel
;test_alu.c pinc_xxx.tab -otest_alu.s -v
;Universal-Tabelle

; --- Anfang ---
        BEGCODE
;/************************************************************************
; *  TEST_ALU.C                                                          *
; *                  Test der arithmetisch/logischen Ausdrcke           *
; *                  =========================================           *
; *                                                                      *
; *  13.06.93    Bodo Wenzel     Erstellung                              *
; ************************************************************************/
;
;char    c1;
;int     i1;
;
;func()
;  {
        PUBFUNC ccfunc
;  char  c2,*cp;
;  int   i2,*ip;
;
;/* Ausdruck */
;  123;
        CORRSP  -14
        LDIMM   123
;
;/* Zuweisung */
;  c1='a';
        LDIMM   97
        STACHAR ccc1
;  c2='b';
        LDLADDR 12
        PUSH
        LDIMM   98
        STICHAR
;  i1=123;
        LDIMM   123
        STAINT  cci1
;  i2=456;
        LDLADDR 4
        PUSH
        LDIMM   456
        STIINT
;
;/* mehrfache Zuweisung */
;  i1=i2=c1=c2=0;
        LDLADDR 4
        PUSH
        LDLADDR 16
        PUSH
        LDIMM   0
        STICHAR
        STACHAR ccc1
        STIINT
        STAINT  cci1
;
;/* Disjunktion / Exklusiv-oder / Konjunktion */
;  123 | 456 ^ 789 & 123;
        LDIMM   123
        PUSH
        LDIMM   456
        PUSH
        LDIMM   789
        PUSH
        LDIMM   123
        AND
        XOR
        OR
;
;/* Vergleiche mit Werten */
;  i1==i2;
        LDAINT  cci1
        PUSH
        LDLADDR 8
        LDIINT
        EQ
;  i1!=i2;
        LDAINT  cci1
        PUSH
        LDLADDR 8
        LDIINT
        NE
;  i1<i2;
        LDAINT  cci1
        PUSH
        LDLADDR 8
        LDIINT
        SLT
;  i1<=i2;
        LDAINT  cci1
        PUSH
        LDLADDR 8
        LDIINT
        SLE
;  i1>i2;
        LDAINT  cci1
        PUSH
        LDLADDR 8
        LDIINT
        SGT
;  i1>=i2;
        LDAINT  cci1
        PUSH
        LDLADDR 8
        LDIINT
        SGE
;
;/* Vergleiche mit Zeigern */
;  &i1==ip;
        LDGADDR cci1
        PUSH
        LDLADDR 4
        LDIINT
        EQ
;  &i1!=ip;
        LDGADDR cci1
        PUSH
        LDLADDR 4
        LDIINT
        NE
;  &i1<ip;
        LDGADDR cci1
        PUSH
        LDLADDR 4
        LDIINT
        ULT
;  &i1<=ip;
        LDGADDR cci1
        PUSH
        LDLADDR 4
        LDIINT
        ULE
;  &i1>ip;
        LDGADDR cci1
        PUSH
        LDLADDR 4
        LDIINT
        UGT
;  &i1>=ip;
        LDGADDR cci1
        PUSH
        LDLADDR 4
        LDIINT
        UGE
;
;/* links Schieben / rechts Schieben */
;  123<<456;
        LDIMM   123
        PUSH
        LDIMM   456
        SHL
;  123>>456;
        LDIMM   123
        PUSH
        LDIMM   456
        SHR
;
;/* Addition/Subtraktion mit Werten */
;  i1+2;
        LDAINT  cci1
        PUSH
        LDIMM   2
        ADD
;  c1-3;
        LDACHAR ccc1
        PUSH
        LDIMM   3
        SUB
;
;/* Addition/Subtraktion mit Zeigern */
;  ip+2;
        LDLADDR 0
        LDIINT
        PUSH
        LDIMM   2
        CNVPTR
        ADD
;  cp-3;
        LDLADDR 8
        LDIINT
        PUSH
        LDIMM   3
        SUB
;
;/* Multiplikation / Division / Modulo-Rechung */
;  123 * 456 / 789 % 123;
        LDIMM   123
        PUSH
        LDIMM   456
        MUL
        PUSH
        LDIMM   789
        DIV
        PUSH
        LDIMM   123
        MOD
;
;/* Priorisierte Berechnungen */
;  123 | 456 ^ 789 & 123 >= 123 << 456 + 789 * 123 / 456 % 789;
        LDIMM   123
        PUSH
        LDIMM   456
        PUSH
        LDIMM   789
        PUSH
        LDIMM   123
        PUSH
        LDIMM   123
        PUSH
        LDIMM   456
        PUSH
        LDIMM   789
        PUSH
        LDIMM   123
        MUL
        PUSH
        LDIMM   456
        DIV
        PUSH
        LDIMM   789
        MOD
        ADD
        SHL
        SGE
        AND
        XOR
        OR
;  123 % 456 / 789 * 123 + 123 << 456 >= 789 & 123 ^ 456 | 789;
        LDIMM   123
        PUSH
        LDIMM   456
        MOD
        PUSH
        LDIMM   789
        DIV
        PUSH
        LDIMM   123
        MUL
        PUSH
        LDIMM   123
        ADD
        PUSH
        LDIMM   456
        SHL
        PUSH
        LDIMM   789
        SGE
        PUSH
        LDIMM   123
        AND
        PUSH
        LDIMM   456
        XOR
        PUSH
        LDIMM   789
        OR
;
;/* Pre- und Postinkrement und -dekrement mit Werten */
;  i1++;
        LDAINT  cci1
        INC
        STAINT  cci1
        DEC
;  --i1;
        LDAINT  cci1
        DEC
        STAINT  cci1
;  c1++;
        LDACHAR ccc1
        INC
        STACHAR ccc1
        DEC
;  --c1;
        LDACHAR ccc1
        DEC
        STACHAR ccc1
;
;/* Pre- und Postinkrement und -dekrement mit Zeigern */
;  ip++;
        LDLADDR 0
        PUSH
        LDIINT
        INCI
        STIINT
        DECI
;  --ip;
        LDLADDR 0
        PUSH
        LDIINT
        DECI
        STIINT
;  cp++;
        LDLADDR 8
        PUSH
        LDIINT
        INC
        STIINT
        DEC
;  --cp;
        LDLADDR 8
        PUSH
        LDIINT
        DEC
        STIINT
;
;/* Negatives Vorzeichen */
;  -i1;
        LDAINT  cci1
        NEG
;
;/* Adresse referenzieren und dereferenzieren */
;  &i1;
        LDGADDR cci1
;  *ip;
        LDLADDR 0
        LDIINT
        LDIINT
;
;/* Indexrechnung mit Zeigern */
;  ip[3];
        LDLADDR 0
        LDIINT
        PUSH
        LDIMM   3
        CNVPTR
        ADD
        LDIINT
;  cp[3];
        LDLADDR 8
        LDIINT
        PUSH
        LDIMM   3
        ADD
        LDICHAR
;
;/* Klammern */
;  123 + ( 456 * 789 );
        LDIMM   123
        PUSH
        LDIMM   456
        PUSH
        LDIMM   789
        MUL
        ADD
;  ( 123 + 456 ) * 789;
        LDIMM   123
        PUSH
        LDIMM   456
        ADD
        PUSH
        LDIMM   789
        MUL
;
;/* Lokaler Wert */
;  i2;
        LDLADDR 4
        LDIINT
;  c2;
        LDLADDR 12
        LDICHAR
;
;/* Globaler Wert */
;  i1;
        LDAINT  cci1
;  c1;
        LDACHAR ccc1
;
;/* Dezimalzahl ohne Vorzeichen */
;  123;
        LDIMM   123
;
;/* Dezimalzahl mit Vorzeichen */
;  +123;
        LDIMM   123
;  -123;
        LDIMM   123
        NEG
;
;/* Hexzahl ohne Vorzeichen */
;  0xAB;
        LDIMM   171
;
;/* Hexzahl mit Vorzeichen */
;  +0xAB;
        LDIMM   171
;  -0xAB;
        LDIMM   171
        NEG
;
;/* Einzelzeichen */
;  'a';
        LDIMM   97
;
;/* Mehrstellige Zeichen */
;  'ab';
        LDIMM   24930
;
;/* String */
;  "Text";
        LDDADDR cc0+0
;
;  }
        CORRSP  14
        RETURN
;
;/* --- Ende ----------------------------------------------------------- */
;
;
        ENDCODE
        BEGDATA
        CLABEL  cc0
        DEFCHAR 84,101,120,116,0
        ENDDATA
        BEGBSS
        PUBCHAR ccc1
        DSCHAR  2
        PUBINT  cci1
        DSINT   1
        ENDBSS
        END
; --- Ende ---
;Es gab 0 Fehler beim Compilieren.
