/************************************************************************
 *  TEST_PR2.C								*
 *			Test der sprintf()-Funktion (Teil 2)		*
 *			====================================		*
 *									*
 *  02.04.94	Bodo Wenzel	Erstellung (spezielle Version 51I)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

/* === Funktionsprototypen ============================================ */

puts_c(char *s);
str_c1(char *s);
str_c2(char *s);
str_c3(char *s);

prt_p(char *f,char *p);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  getchar();

  for (;;)
    {
    puts_c("Gestartet...\r\n");

    prt_p(str_c1("%s"),str_c2("Test"));
    prt_p(str_c1("%-s"),str_c2("Test"));
    prt_p(str_c1("%5s"),str_c2("Test"));
    prt_p(str_c1("%-5s"),str_c2("Test"));
    prt_p(str_c1("%0s"),str_c2("Test"));
    prt_p(str_c1("%-0s"),str_c2("Test"));
    prt_p(str_c1("%05s"),str_c2("Test"));
    prt_p(str_c1("%-05s"),str_c2("Test"));
    getchar();

    prt_p(str_c1("%d 0x%x \"%s\" '%c'"),str_c2("Test"));
    }
  }

/* === Hilfsfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

char	str1[20],str2[10],str3[35];

str_c1(char *s)
/*-----------*/
  {
  char	*p;

  p=str1;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str1);
  }

str_c2(char *s)
/*-----------*/
  {
  char	*p;

  p=str2;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str2);
  }

str_c3(char *s)
/*-----------*/
  {
  char	*p;

  p=str3;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str3);
  }

/* === Test von sprintf() ============================================= */

prt_p(char *f,char *p)
/*------------------*/
  {
  char	s[35];
  int	i;

  strcpy(s,str_c3("******************************"));
  i=sprintf(s,f,p);
  putchar('"');
  puts(f);
  puts_c("\"(\"");
  puts(p);
  puts_c("\")=>(");
  hex(i);
  puts_c(")\"");
  puts(s);
  puts_c("\"\r\n");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
