/************************************************************************
 *  FOPEN.C                                                             *
 *              Datei ffnen (Version fr Atari-TOS, long model)        *
 *              ================================================        *
 *                                                                      *
 *  22.08.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*      fopen()         ffnet eine Datei (wenn zum Schreiben, wird     */
/*                      eine vorhandene Datei geleert!), liefert NULL   */
/*                      bei Fehler, sonst das Dateihandle               */
/*      name            Zeiger auf die Zeichenkette des Namens          */
/*      mode            Zeiger auf die Zeichenkette des Modus           */

fopen(char *name,char *mode)
/*------------------------*/
  {
#asm
        move.l  4(sp),a0
        move.b  (a0),d0
        cmp.b   #'r',d0
        beq.s   cc_01
        cmp.b   #'R',d0
        beq.s   cc_01
        cmp.b   #'w',d0
        beq.s   cc_02
        cmp.b   #'W',d0
        beq.s   cc_02
        bra.s   cc_03

cc_01:
        move.l  8(sp),d0
        clr.w   -(sp)
        move.l  d0,-(sp)
        move.w  #$3D,-(sp)
        trap    #1
        addq.l  #8,sp
        tst.w   d0
        bmi.s   cc_03
        bra.s   cc_04

cc_02:
        move.l  8(sp),d0
        clr.w   -(sp)
        move.l  d0,-(sp)
        move.w  #$3C,-(sp)
        trap    #1
        addq.l  #8,sp
        tst.w   d0
        bmi.s   cc_03
        bra.s   cc_04

cc_03:
        clr.w   d0
cc_04:
        ext.l   d0
#endasm
  }

/* === Ende =========================================================== */
