/************************************************************************
 *  _DIVMOD.C                                                           *
 *              Division (Version fr Atari-TOS, long model)            *
 *              ============================================            *
 *                                                                      *
 *  22.08.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*      _divmod()       berechnet Quotient und Rest                     */
/*      d0              I: Divisor                                      */
/*                      O: Quotient                                     */
/*      d1              I: Dividend                                     */
/*                      O: Rest                                         */

_divmod()
/*-----*/
  {
#asm
        move.l  d1,d6           ;Dividend merken
        move.l  d0,d7
        bpl.s   cc_01           ;Divisor positiv ?
        neg.l   d0
        eor.l   d1,d7
        bmi.s   cc_02           ;Dividend positiv ?
        neg.l   d1
        bra.s   cc_02
cc_01:
        eor.l   d1,d7
        bpl.s   cc_02           ;Dividend positiv ?
        neg.l   d1
cc_02:

        clr.l   d2
        clr.l   d3
        clr.l   d4              ;D0D2=divisor D3D1=dividend D4=quotient
        move.w  #32-1,d6
cc_03:
        lsr.l   #1,d0
        roxr.l  #1,d2           ;Divisor schieben
        lsl.l   #1,d4           ;Quotient schieben
        sub.l   d2,d1
        subx.l  d0,d3
        bcc.s   cc_04           ;Subtraktion gelungen ?
        add.l   d2,d1
        addx.l  d0,d3           ;korrigieren
        bra.s   cc_05
cc_04:
        addq.l  #1,d4           ;Quotient erhhen
cc_05:
        dbra    d6,cc_03        ;noch nicht alle Bits ?
        move.l  d4,d0           ;Quotient holen

        tst.l   d7
        bpl.s   cc_06           ;Quotient positiv lassen ?
        neg.l   d0
cc_06:
        tst.l   d6
        bpl.s   cc_07           ;Rest positiv lassen ?
        neg.l   d1
cc_07:
#endasm
  }

/* === Ende =========================================================== */
