/************************************************************************
 *  _STARTUP.C                                                          *
 *              Startup-Code (Version fr Atari-TOS, long model)        *
 *              ================================================        *
 *                                                                      *
 *  22.08.93    Bodo Wenzel     V1.0, Erstellung                        *
 ************************************************************************/

/*              ! ! !   A C H T U N G   ! ! !                           */
/*      Dieses Modul mu als erstes gelinkt werden!                     */

/* -------------------------------------------------------------------- */
/*      Mit diesem Code wird jedes Programm gestartet. Er liefert an    */
/*      den aufrufenden Proze den Wert der aufgerufenen "main"-        */
/*      Funktion zurck.                                                */

/* === Einfgedateien ================================================= */

#include "stdlib.h"

/* === Globale Variablen ============================================== */

        int     _app;           /* Flag 0=Accessory, 1=Programm         */
        char    *_basepage;     /* Zeiger auf die BASEPAGE              */
extern  char    *_stack;        /* Stack wird extern vereinbart         */

/* === Funktionsprototypen ============================================ */

main(char *arg);                /* Hauptfunktion des Programms          */

/* === Funktion ======================================================= */

_startup()
/*------*/
  {
#asm
        bra.s   cc_02           ;Copyright berspringen

        dc.b    "PINC fr Atari-TOS (long model) V1.0 "
        dc.b    "(C)1993 Bodo Wenzel"
cc_01:
        dc.b    0               ;leerer String
        even

cc_02:
        move.l  a0,d4
        bne.s   cc_03           ;bei Accessory hier BP-Zeiger

        move.l  4(sp),d4        ;sonst hier

        move.l  d4,a0
        move.l  #$100,d0
        add.l   12(a0),d0
        add.l   20(a0),d0
        add.l   28(a0),d0       ;bentigten Speicher berechnen

        lea     128(a0),a6
        clr.w   d1
        move.b  (a6)+,d1
        clr.b   (a6,d1.w)       ;Ende der Kommandozeile setzen

        move.l  d0,-(sp)
        pea     (a0)
        clr.w   -(sp)
        move.w  #$4A,-(sp)
        trap    #1
        lea     12(sp),sp       ;nicht bentigten Speicher freigeben

        st      d1              ;ist Programm
        bra.s   cc_04

cc_03:
        lea     cc_01,a6        ;leere Kommandozeile
        sf      d1              ;ist Accessory
cc_04:
        ext.w   d1
        ext.l   d1
        move.l  d1,cc_app       ;Art merken
        move.l  d4,cc_basepage  ;Zeiger auf BP merken

        move.l  #cc_stack,d0
        and.l   #$FFFFFFFC,d0
        move.l  d0,sp           ;Stack setzen

        move.l  a6,-(sp)        ;Zeiger auf Parameter von Hand
#endasm
/*      int     ret;                                                    */
/*      ret=main(arg);                                                  */
/*      char    *arg;                                                   */
        exit(main());           /* ohne Parameter aufrufen              */
  }

/* === Ende =========================================================== */
