/************************************************************************
 *  FGETS.C                                                             *
 *                  STDIO-Funktion fgets() (fr PINC)                   *
 *                  =================================                   *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

#include "stdio.h"

/* -------------------------------------------------------------------- */
/*      fgets()         liest eine Zeichenkette aus einer Datei,        */
/*                      liefert NULL bei Fehlern, sonst s               */
/*      s               Zeiger auf den Zielpuffer                       */
/*      n               Maximalzahl Zeichen - 1 (fr '\0')              */
/*      f               Datei                                           */

fgets(char *s,int n,FILE *f)
/*------------------------*/
  {
  int   c;
  char  *p;

  p=s;
  while (--n>0)
    {
    if ((c=fgetc(f))==EOF)
      break;
    if ((*p++=c)=='\n')
      break;
    }
  *p='\0';
  if (c==EOF & p==s)
    return(NULL);
  else
    return(s);
  }

/* === Ende =========================================================== */
