/************************************************************************
 *  ITOSTR.C                                                            *
 *                  STDLIB-Funktion itostr() (fr PINC)                 *
 *                  ===================================                 *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* -------------------------------------------------------------------- */
/*      itostr()        wandelt Zahl in Zeichenkette um                 */
/*      s               Zeiger auf den Zielpuffer                       */
/*      b               Zahlenbasis fr die Umwandlung                  */
/*      n               umzuwandelnde Zahl                              */

itostr(char *s,int b,int n)
/*-----------------------*/
  {
  char  *p,c;
  int   sign;

  p=s;
  if (sign=n<0)
    n=-n;
  do
    {
    c=n%b;
    n=n/b;
    if (c<10)
      *p++=c+'0';
    else
      *p++=c+'A'-10;
    }
  while (n);
  if (sign)
    *p++='-';
  *p='\0';
  while (--p>s)
    {
    c=*p;
    *p=*s;
    *s++=c;
    }
  }

/* === Ende =========================================================== */
