/************************************************************************
 *  STRTOI.C                                                            *
 *                  STDLIB-Funktion strtoi() (fr PINC)                 *
 *                  ===================================                 *
 *                                                                      *
 *  15.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

#include "ctype.h"

/* -------------------------------------------------------------------- */
/*      strtoi()        wandelt Zeichenkette in Zahl um, liefert Zahl   */
/*      s               Zeiger auf den Quellpuffer                      */
/*      b               Zahlenbasis fr die Umwandlung                  */
/*      n               Zeiger auf maximale Zeichenzahl, wird ersetzt   */
/*                      durch Anzahl umgewandelter Zeichen              */

strtoi(char *s,int b,int *n)
/*------------------------*/
  {
  int   i,v,sign,c;
  char  *p;

  p=s;
  i=*n;
  sign=0;
  if (*p=='+')
    {
    sign=1;
    ++p;
    --i;
    }
  else if (*p=='-')
    {
    sign=-1;
    ++p;
    --i;
    }
  v=0;
  while (1)
    {
    if (*n)
      if (i<=0)
        break;
    if ((c=*p)=='\0')
      break;
    if (isdigit(c))
      c=c-'0';
    else
      c=toupper(c)-'A'+10;
    if (c<0 | c>=b)
      break;
    v=v*b+c;
    ++p;
    --i;
    }
  *n=i=p-s;
  if (sign)
    {
    if (i==1)
      *n=0;
    if (sign<0)
      return(-v);
    else
      return(v);
    }
  else
    return(v);
  }

/* === Ende =========================================================== */
