/************************************************************************
 *  TEST_MEM.C                                                          *
 *                      Test von Speicherverwaltung                     *
 *                      ===========================                     *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "stdlib.h"

/* === Konstanten ===================================================== */

#define REST    30000

/* === Funktionsprototypen ============================================ */

hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char *p1,*p2;
  int i;

  i=malloc(-1);
  puts("Maximaler Speicher=0x");
  hex(i);
  puts(" Bytes:\r\n");
  p1=NULL;
  p2=NULL;
  if (i>REST)
    {
    if (p1=malloc(i-REST))
      {
      puts("Konnte groen Block anfordern, Adresse=0x");
      hex(p1);
      puts(".\r\n");
      }
    else
      puts("Konnte groen Block nicht anfordern.\r\n");
    }
  if (p2=malloc(REST+2))
    {
    puts("Konnte kleinen Block anfordern, Adresse=0x");
    hex(p2);
    puts(".\r\n");
    }
  else
    puts("Konnte kleinen Block nicht anfordern.\r\n");
  if (p1!=NULL)
    free(p1);
  if (p2!=NULL)
    free(p2);
  return(0);
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  nib(n>>28);
  nib(n>>24);
  nib(n>>20);
  nib(n>>16);
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
