/************************************************************************
 *  TEST_TYP.C                                                          *
 *                      Test von CTYPE-Funktionen                       *
 *                      =========================                       *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "ctype.h"
#include "stdio.h"

/* === Funktionsprototypen ============================================ */

log(int l);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  int     i;

  for (i=0; i<0x100; ++i)
    {
    if ((i&0x0F)==0x00)
      puts("c: alnum alpha digit lower upper space lower upper\r\n");
    hex(i);
    log(isalnum(i));
    log(isalpha(i));
    log(isdigit(i));
    log(islower(i));
    log(isupper(i));
    log(isspace(i));
    puts("   ");
    hex(tolower(i));
    puts("    ");
    hex(toupper(i));
    if ((i&0x0F)==0x0F)
      getchar();
    puts("\r\n");
    }
  return(0);
  }

/* === Ausgabefunktionen ============================================== */

log(int l)
/*------*/
  {
  if (l)
    puts("   1  ");
  else
    puts("   0  ");
  }

hex(int n)
/*------*/
  {
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
