;PINC C-Compiler V1.0, Copyright 1993 Bodo Wenzel
;test_tab.c test.tab -otest_tab.s -v
;Test-Tabelle

; --- Anfang ---
   BEGCODE
;/************************************************************************
; *  TEST_TAB.C                                                          *
; *                  Test der bersetzungstabelle                        *
; *                  ============================                        *
; *                                                                      *
; *  22.08.93    Bodo Wenzel     Erstellung                              *
; ************************************************************************/
;
;/* Tabellenname automatisch */
;
;/* maximale Anzahl Zeichen pro Name */
;verylongname()
;  {
   PUBFUNC  ccverame
;
;/* Anzahl Werte bei Konstanten */
;  "012345678901234567890123456789";
   LDDADDR  cc0+0
   DUMMY    STR
;  }
   RETURN
;
;/* Stack- und Typenparameter in anderen Tests... */
;
;/* Kommentare automatisch */
;
;/* Segmentierung automatisch */
;
;/* Externe Symbole */
;                ef();
;extern  char    ec;
;extern  int     ei;
;
;/* Globale Symbole (externes s. o.) */
;gf()
;  {
   PUBFUNC  ccgf
;  ec;
   LDACHAR  ccec
;  ei;
   LDAINT   ccei
   DUMMY    SYM
;  }
   RETURN
;char    gc;
;int     gi;
;int     *gp;
;
;/* fr die weiteren Tests */
;test()
;  {
   PUBFUNC  cctest
;  int   li;
;  char  lc;
;
;/* interne Sprungmarke */
;  if (1) 123;
   CORRSP   -4
   DUMMY    VAL
   DUMMY    VAL
   LDIMM 1
   IFFJUMP  cc1
   LDIMM 123
;
;/* char-Definition und Platzreservierung fr int und char s. o. */
;
;/* Adressen in PRI */
;  gf;
   LABEL cc1
   DUMMY    JMP
   LDGADDR  ccgf
   DUMMY    SYM
;  "data";
   LDDADDR  cc0+31
   DUMMY    STR
;  &li;
   LDLADDR  2
   DUMMY    VAL
;
;/* Laden */
;  gi;
   LDAINT   ccgi
   DUMMY    SYM
;  gc;
   LDACHAR  ccgc
;  li;
   LDLADDR  2
   DUMMY    VAL
   LDIINT
   DUMMY    DIR
;  lc;
   LDLADDR  0
   DUMMY    VAL
   LDICHAR
   DUMMY    DIR
   DUMMY    DIR
;
;/* Speichern */
;  gi=0;
   LDIMM 0
   STAINT   ccgi
;  gc=0;
   LDIMM 0
   STACHAR  ccgc
;  li=0;
   LDLADDR  2
   DUMMY    VAL
   PUSH
   LDIMM 0
   STIINT
;  lc=0;
   LDLADDR  0
   DUMMY    VAL
   PUSH
   LDIMM 0
   STICHAR
;
;/* int-Zeiger konvertieren */
;  &gp[1];
   LDAINT   ccgp
   DUMMY    SYM
   PUSH
   LDIMM 1
   CNVPTR
   ADD
;
;/* Stackbefehle automatisch */
;
;/* Unterprogramme */
;  ef();
   CALL  ccef
   DUMMY    STR
;  123();
   LDIMM 123
   PUSH
   CALLSTK  0
   CORRSP   2
   DUMMY    VAL
   DUMMY    VAL
;
;/* Sprnge */
;  if (1) ;
   LDIMM 1
   IFFJUMP  cc2
;  do ; while (2);
   LABEL cc2
   DUMMY    JMP
   LABEL cc3
   DUMMY    JMP
   LABEL cc4
   DUMMY    JMP
   LDIMM 2
   IFTJUMP  cc3
   LABEL cc5
   DUMMY    JMP
;  switch (3) { case 1: ; }
   LDIMM 3
   PUSH
   CPIMM 1
   IFNEJMP  cc7
   LABEL cc7
   DUMMY    JMP
   CORRSP   2
   DUMMY    VAL
   DUMMY    VAL
   LABEL cc6
   DUMMY    JMP
;
;/* Berechnungen */
;  123+456;
   LDIMM 123
   PUSH
   LDIMM 456
   ADD
;  123-456;
   LDIMM 123
   PUSH
   LDIMM 456
   SUB
;  123*456;
   LDIMM 123
   PUSH
   LDIMM 456
   MUL
;  123/456;
   LDIMM 123
   PUSH
   LDIMM 456
   DIV
;  123%456;
   LDIMM 123
   PUSH
   LDIMM 456
   MOD
;  123|456;
   LDIMM 123
   PUSH
   LDIMM 456
   OR
;  123^456;
   LDIMM 123
   PUSH
   LDIMM 456
   XOR
;  123&456;
   LDIMM 123
   PUSH
   LDIMM 456
   AND
;  123<<456;
   LDIMM 123
   PUSH
   LDIMM 456
   SHL
;  123>>456;
   LDIMM 123
   PUSH
   LDIMM 456
   SHR
;  -123;
   LDIMM 123
   NEG
;  ++gc;
   LDACHAR  ccgc
   INC
   STACHAR  ccgc
;  ++gp;
   LDAINT   ccgp
   DUMMY    SYM
   INCI
   STAINT   ccgp
;  --gc;
   LDACHAR  ccgc
   DEC
   STACHAR  ccgc
;  --gp;
   LDAINT   ccgp
   DUMMY    SYM
   DECI
   STAINT   ccgp
;
;/* Vergleiche */
;  gi==gi;
   LDAINT   ccgi
   DUMMY    SYM
   PUSH
   LDAINT   ccgi
   DUMMY    SYM
   EQ
;  gi!=gi;
   LDAINT   ccgi
   DUMMY    SYM
   PUSH
   LDAINT   ccgi
   DUMMY    SYM
   NE
;  gi<gi;
   LDAINT   ccgi
   DUMMY    SYM
   PUSH
   LDAINT   ccgi
   DUMMY    SYM
   SLT
;  gi<=gi;
   LDAINT   ccgi
   DUMMY    SYM
   PUSH
   LDAINT   ccgi
   DUMMY    SYM
   SLE
;  gi>gi;
   LDAINT   ccgi
   DUMMY    SYM
   PUSH
   LDAINT   ccgi
   DUMMY    SYM
   SGT
;  gi>=gi;
   LDAINT   ccgi
   DUMMY    SYM
   PUSH
   LDAINT   ccgi
   DUMMY    SYM
   SGE
;  gp<gp;
   LDAINT   ccgp
   DUMMY    SYM
   PUSH
   LDAINT   ccgp
   DUMMY    SYM
   ULT
;  gp<=gp;
   LDAINT   ccgp
   DUMMY    SYM
   PUSH
   LDAINT   ccgp
   DUMMY    SYM
   ULE
;  gp>gp;
   LDAINT   ccgp
   DUMMY    SYM
   PUSH
   LDAINT   ccgp
   DUMMY    SYM
   UGT
;  gp>=gp;
   LDAINT   ccgp
   DUMMY    SYM
   PUSH
   LDAINT   ccgp
   DUMMY    SYM
   UGE
;
;  }
   CORRSP   4
   DUMMY    VAL
   DUMMY    VAL
   RETURN
;
;/* --- Ende ----------------------------------------------------------- */
;
;
   EXTFUNC  _EXJMP
   EXTFUNC  _EXSYM
   EXTFUNC  _EXVAL
   EXTFUNC  _EXYM1
   EXTFUNC  _EXYM2
   EXTFUNC  _EXDIR
   EXTFUNC  _EXIR1
   EXTFUNC  _EXIR2
   EXTFUNC  _EXAL1
   EXTFUNC  _EXAL2
   EXTFUNC  _EXSTR
   EXTFUNC  ccef
   ENDCODE
   BEGDATA
   CLABEL   cc0
   DEFCHAR  48,49,50,51,52,53,54,55,56,57
   DEFCHAR  48,49,50,51,52,53,54,55,56,57
   DEFCHAR  48,49,50,51,52,53,54,55,56,57
   DEFCHAR  0,100,97,116,97,0
   ENDDATA
   BEGBSS
   EXTCHAR  ccec
   EXTINT   ccei
   PUBCHAR  ccgc
   DSCHAR   2
   PUBINT   ccgi
   DSINT 1
   PUBINT   ccgp
   DSINT 1
   ENDBSS
   END
; --- Ende ---
;Es gab 0 Fehler beim Compilieren.
